package org.jeecg.modules.stm.risk.scenario.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.modules.stm.risk.scenario.entity.StRiskScenario;
import org.jeecg.modules.stm.risk.scenario.service.IStRiskScenarioService;

import com.baomidou.mybatisplus.core.metadata.IPage;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.modules.stm.risk.scenario.vo.StRiskScenarioVo;

/**
 * @Description: 风险场景
 * @Author: yzh
 * @Date:   2023-03-05
 * @Version: V1.0
 */

@RestController
@RequestMapping("/risk.scenario/stRiskScenario")
@Slf4j
public class StRiskScenarioController extends JeecgController<StRiskScenario, IStRiskScenarioService> {
	@Autowired
	private IStRiskScenarioService stRiskScenarioService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stRiskScenario
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "风险场景-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<StRiskScenario>> queryPageList(StRiskScenario stRiskScenario,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
//		QueryWrapper<StRiskScenario> queryWrapper = QueryGenerator.initQueryWrapper(stRiskScenario, req.getParameterMap());
//		Page<StRiskScenario> page = new Page<StRiskScenario>(pageNo, pageSize);
//		IPage<StRiskScenario> pageList = stRiskScenarioService.page(page, queryWrapper);
		IPage<StRiskScenario> pageList = stRiskScenarioService.defPage(stRiskScenario,pageNo,pageSize,req.getParameterMap());
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stRiskScenario
	 * @return
	 */
	@AutoLog(value = "风险场景-添加")

	@RequiresPermissions("risk.scenario:st_risk_scenario:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StRiskScenarioVo stRiskScenario) {
		stRiskScenarioService.save(stRiskScenario);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stRiskScenario
	 * @return
	 */
	@AutoLog(value = "风险场景-编辑")

	@RequiresPermissions("risk.scenario:st_risk_scenario:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StRiskScenarioVo stRiskScenario) {
		stRiskScenarioService.updateById(stRiskScenario);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "风险场景-通过id删除")

	@RequiresPermissions("risk.scenario:st_risk_scenario:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stRiskScenarioService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "风险场景-批量删除")

	@RequiresPermissions("risk.scenario:st_risk_scenario:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stRiskScenarioService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "风险场景-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<StRiskScenario> queryById(@RequestParam(name="id",required=true) String id) {
		StRiskScenario stRiskScenario = stRiskScenarioService.getById(id);
		if(stRiskScenario==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stRiskScenario);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stRiskScenario
    */
    @RequiresPermissions("risk.scenario:st_risk_scenario:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StRiskScenario stRiskScenario) {
        return super.exportXls(request, stRiskScenario, StRiskScenario.class, "风险场景");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("risk.scenario:st_risk_scenario:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StRiskScenario.class);
    }

}
